/*
------------------------------------------------------------------------
  Programme: THAL'S.C

  Module   : Programme principal
			      Borland Turbo C++ version 1.00

  Auteur   : Jean Philippe BOCQUENET

  Date     : 16/IV/1995

  Objet    : Programme d'aide au  positionnement  d'un  point dans le
	     quadrillage.
	     Ce programme permet de coter en X,Y un point par rapport
	     au quadrillage gnral du site,  l'aide de deux doubles
	     dcamtres (triangulation).

-----------------------------------------------------------------------
*/

#include <dos.h>
#include <math.h>
#include <bios.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>

#define F1                      0x3B00
#define F2                      0x3c00
#define F3                      0x3d00
#define F4                      0x3e00
#define F5                      0x3f00
#define F9                      0x4300
#define F10                     0x4400
#define SHIFT_F10               0x5d00



/* --------------------------------------------------------- */
void bordure(int color)
{
  union REGS regs;
  regs.h.ah = 0x10;
  regs.h.al = 1;
  regs.h.bh = color & 15;
  int86(0x10, &regs, &regs);
}

/* --------------------------------------------------------- */
void logo()
{
  int x=8;
  int y=1;

  bordure(1);
  window(1,1,80,25); textbackground(BLACK);  clrscr();  textcolor(BLUE);
  gotoxy( 1,11); cprintf("");
  textcolor(LIGHTGREEN);
  gotoxy(x+34, y);  cprintf("Ŀ");
  gotoxy(x, y+ 1);  cprintf(" ͻ");
  gotoxy(x, y+ 2);  cprintf(" Ŀ Ŀ   ĿĿ  Ŀ Ŀ ");
  gotoxy(x, y+ 3);  cprintf("       Ŀ       ۿ   ");
  gotoxy(x, y+ 4);  cprintf("                            Ŀ ");
  gotoxy(x, y+ 5);  cprintf("                                   ");
  gotoxy(x, y+ 6);  cprintf("                        Ŀ     ");
  gotoxy(x, y+ 7);  cprintf("                              ");
  gotoxy(x, y+ 8);  cprintf(" ͼ");
  gotoxy(x+43, y+ 9);  cprintf(" (c)-1994    Version 2.00");
  textcolor(YELLOW);
  gotoxy(1,y+8);  cprintf("ARCHE");
  gotoxy(1,y+9);  cprintf("LOGICK");
  textcolor(LIGHTRED);
  gotoxy(6,y+8);  cprintf("");
  gotoxy(2,y+9);  cprintf("");
  window(1,12,80,25); textbackground(BLUE); textcolor(WHITE); clrscr(); window(1,1,80,25);
}

void menu(void)
{
  logo();
  textcolor(WHITE);
  gotoxy(10,15); cprintf("[F1] - Nom du carr d'origine (Ref. X,Y)");
  gotoxy(10,17); cprintf("[F2] - Distance sur l'axe des ordonnes");
  gotoxy(10,19); cprintf("[F3] - Calculs du carr et des coordonnes");
  textcolor(YELLOW);
  gotoxy(10,24); cprintf("[SHIFT][F10] - Quitter");
  textcolor(LIGHTGREEN);
  gotoxy(48,24); cprintf("Auteur : Jean Philippe BOCQUENET");
  textcolor(WHITE);
}

void schema(void)
{
  textcolor(BLACK);
  gotoxy(56,17); cprintf("   2");
  gotoxy(56,18); cprintf("     ");
  gotoxy(56,19); cprintf("     \\");
  gotoxy(56,20); cprintf("       \\");
  gotoxy(56,21); cprintf("         \\");
  gotoxy(56,22); cprintf("y          \\");
  gotoxy(56,23); cprintf("x  \\  ");
  gotoxy(56,24); cprintf("   1           \\ ->");
  textcolor(WHITE);
}

/* --------------------------------------------------------- */
void main(void)
{
  FILE *fic;
  unsigned int touche;
  int axe1, axe2, point1, point2, sens;
  int chiffre, inter;
  int xcarre, ycarre;
  int dec, sign;
  int numero;
  int numero2,xcarre2,ycarre2;
  char carretemp[30];
  double ptref_axe, pt_inter_axes, pt_origin_mesure;
  double distance, rapport;
  double longinter, dist_objet_diagonale, dist_sur_axe_axis;
  double inter_diag_axis_carre, inter_diagonale_axis;
  double xcoord, ycoord, x, y;
  double carre1, carre2;
  double xcar, ycar;
  char lettre, lettre2[8];
  char *ptr;
  char *string="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  char carre[30], string2[30], designation[30];

  fic = fopen("ESSAI.PIT","a+t");
 _setcursortype(_NOCURSOR);

 for(;;)
 {
  clrscr();
  menu();
  touche = bioskey(0);
  switch(touche)
 {
  case F1:
	clrscr();
	logo();

	schema();
	_setcursortype(_NORMALCURSOR);
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(56,25); cprintf("     A B C DEF... .  ");

	textcolor(WHITE);
	gotoxy(2,13);
	printf("Entrez la lettre de dpart du carroyage (abscisses)(A,B,C,..) : ");
	lettre = getchar();
	fflush(stdin);

	textcolor(BLUE);
	gotoxy(56,25); cprintf("     A B C DEF... .  ");

	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(55,20); cprintf(" . ");
	gotoxy(55,21); cprintf(" 3 ");
	gotoxy(55,22); cprintf(" 2 ");
	gotoxy(55,23); cprintf(" 1 ");
	textcolor(WHITE);

	gotoxy(2,15);
	printf("Entrez le chiffre de dpart du carroyage (ordonnes)(1,2,3,.) : ");
	lettre2[0]=6;
	ptr=cgets(lettre2);
	chiffre = atoi(ptr);
	fflush(stdin);
	textcolor(WHITE);
	_setcursortype(_NOCURSOR);
	break;

  case F2:
	clrscr();
	logo();
	schema();
	_setcursortype(_NORMALCURSOR);
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(61,23); cprintf("");
	textcolor(WHITE);
	gotoxy(5,18);
	printf("Point de dpart sur l'axe des ordonnes : ");
	scanf("%lf",&pt_inter_axes);
	fflush(stdin);
	textcolor(BLACK);
	gotoxy(61,23); cprintf("");
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(61,18); cprintf("");
	textcolor(WHITE);
	gotoxy(5,19);
	printf("Point de  fin  sur  l'axe des ordonnes : ");
	scanf("%lf",&pt_origin_mesure);
	fflush(stdin);
	distance = pt_origin_mesure-pt_inter_axes;
	textcolor(BLACK);
	gotoxy(61,18); cprintf("");
	textcolor(WHITE);
	gotoxy(5,21);
	printf("Distance entre les points : %2.0f m.",distance);
	_setcursortype(_NOCURSOR);
	getch();
	break;

  case F3:
      do
       {
	clrscr();
	logo();
	schema();
	_setcursortype(_NORMALCURSOR);
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(62,19); cprintf("\\");
	gotoxy(62,20); cprintf("  \\");
	gotoxy(62,21); cprintf("    \\");
	gotoxy(62,22); cprintf("      \\");
	gotoxy(70,23); cprintf("\\");
	gotoxy(62,24); cprintf("          \\");
	textcolor(WHITE);
	gotoxy(5,14);
	printf("Distance de l'objet sur la diagonale : ");
	scanf("%lf",&dist_objet_diagonale);
	fflush(stdin);
	textcolor(BLACK);
	gotoxy(62,19); cprintf("\\");
	gotoxy(62,20); cprintf("  \\");
	gotoxy(62,21); cprintf("    \\");
	gotoxy(62,22); cprintf("      \\");
	gotoxy(70,23); cprintf("\\");
	gotoxy(62,24); cprintf("          \\");
	textcolor(LIGHTMAGENTA+BLINK);
	gotoxy(61,23); cprintf("");
	textcolor(WHITE);
	gotoxy(5,16);
	printf("Distance sur l'axe des axis : ");
	scanf("%lf",&dist_sur_axe_axis);
	fflush(stdin);
	textcolor(BLACK);
	gotoxy(61,23); cprintf("");
	textcolor(WHITE);
	gotoxy(5,17);
	printf("Dsignation : ");
	scanf("%10s",designation);
	fflush(stdin);

/* Squence de calcul des coordonnes x,y */

	inter_diag_axis_carre = pow(distance,2)+pow(dist_sur_axe_axis,2);
	inter_diagonale_axis = sqrt(inter_diag_axis_carre);

/* objet sur la ligne des abscisses */
       if(dist_objet_diagonale<inter_diagonale_axis)
       {
	rapport = inter_diagonale_axis/dist_objet_diagonale;
	ycoord=distance/rapport;
	y = distance-ycoord;
	xcoord = dist_sur_axe_axis/rapport;
	x = xcoord;

/* calcul la lettre du carr */
	   xcar=modf(x, &carre1);
	   ptr=strchr(string,lettre);
	   inter=(ptr-string);
	   carre1 += inter+1;
	   strncpy(string2,string,carre1);
	   string2[carre1]='\0';
	   strrev(string2);
	   strncpy(carre,string2,1);
	   carre[1]='\0';

/* calcul le chiffre du carr */
	   ycar=modf(y, &carre2);
	   carre2 += chiffre;
	   ptr=(char *)fcvt(carre2,5,&dec,&sign);
	   strncpy(string2,ptr,dec);
	   string2[dec]='\0';

       }
/* objet sous la ligne des abscisses */
       else
       {
	rapport = dist_objet_diagonale/inter_diagonale_axis;
	ycoord = distance*rapport;
	y = ycoord-distance;
	xcoord = dist_sur_axe_axis*rapport;
	x=xcoord;

/* calcul la lettre du carr */
	   xcar=modf(x, &carre1);
	   ptr=strchr(string,lettre);
	   inter=(ptr-string);
	   carre1 += inter+1;
	   strncpy(string2,string,carre1);
	   string2[carre1]='\0';
	   strrev(string2);
	   strncpy(carre,string2,1);
	   carre[1]='\0';

/* calcul le chiffre du carr */
	   ycar=modf(y, &carre2);
	   if (ycar>=0.1) {carre2+=1;}
	   carre2 -= chiffre;
	   ptr=(char *)fcvt(carre2,5,&dec,&sign);
	   strncpy(string2,ptr,dec);
	   string2[dec]='\0';
       }


/* Cr le nom du carr (ex : A4) */
	   strcat(carre,string2);
	   xcar=xcar*100; xcarre=(int)xcar;
	   ycar=ycar*100; ycarre=(int)ycar;

/* Affichage des donnes */
	   textcolor(YELLOW);
	   gotoxy(8,18); cprintf("ͻ");
	   gotoxy(8,19); cprintf("                       ");
	   gotoxy(8,20); cprintf("                       ");
	   gotoxy(8,21); cprintf("                       ");
	   gotoxy(8,22); cprintf("                       ");
	   gotoxy(8,23); cprintf("ͼ");
	   textcolor(LIGHTMAGENTA);
	   gotoxy(10,19); cprintf("CARRE : %s",carre);
	   textcolor(WHITE);
	   gotoxy(10,21); cprintf("Coordonne X : %d",xcarre);
	   gotoxy(10,22); cprintf("Coordonne Y : %d",ycarre);
	   numero=1;

	   fseek(fic,0L,SEEK_SET);
	   do {
		fscanf(fic,"%d,%d,%d,%s",&numero2,&xcarre2,&ycarre2,carretemp);
		ptr=(char *)strcmp(carretemp,carre);
		if(ptr == 0)
		 { numero=numero2+1; }
	      } while(!feof(fic));

	   gotoxy(10,20); cprintf("Numro : %d",numero);
	   fseek(fic,0L,SEEK_END);
	   fprintf(fic,"%3d,	",numero);
	   fprintf(fic,"%3d,	%3d,	",xcarre,ycarre);
	   fprintf(fic,"%6s\n",carre);
	   _setcursortype(_NOCURSOR);
	   textcolor(LIGHTRED);
	   gotoxy(5,25);
	   cprintf("[ESC] - Sortie / Autre touche pour continuer");

       } while(getch()!=27);
       break;

/* Sortie du programme */
  case SHIFT_F10:

	fclose(fic);
	_setcursortype(_NORMALCURSOR);
	textbackground(BLACK); textcolor(WHITE);
	bordure(1);
	clrscr();
	exit(0);
  }
 }
}
